#include "main.h"


Clevel::Clevel()
{

	IsLoaded=false;

}

Clevel::~Clevel()
{

	glDeleteTextures(1,&background);
	FSOUND_Stream_Close(music);

}


void Clevel::loadbackground(string filename)
{

	if(IsLoaded){return;}
	IsLoaded = true;

	SDL_Surface *temp;

	glGenTextures (1, & background);
    glBindTexture (GL_TEXTURE_2D, background);
    // Paramtrage de la texture.
    glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
    glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
    glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);

    temp = IMG_Load(filename.c_str());
	if(temp==NULL)
    {
        std::cerr << "Erreur dans le chargement de l'image de l'arriere plan" << std::endl;
        exit(3);
    }

    // Jonction entre OpenGL et SDL.
    glTexImage2D (GL_TEXTURE_2D, 0, GL_RGB, temp->w, temp->h, 0,
    GL_RGB, GL_UNSIGNED_BYTE, temp-> pixels);

	SDL_FreeSurface(temp);

}


void Clevel::drawbackground()
{

    glBindTexture (GL_TEXTURE_2D, background);

    glBegin(GL_QUADS);
        glTexCoord2f (0, 0) ; glVertex2i(0,0);
        glTexCoord2f (0, 1) ; glVertex2i(0,RESOLUTION_Y);
        glTexCoord2f (1, 1) ; glVertex2i(RESOLUTION_X,RESOLUTION_Y);
        glTexCoord2f (1, 0) ; glVertex2i(RESOLUTION_X,0);
    glEnd();

}

void Clevel::loadmusic(string filename, bool loop)
{

	music = FSOUND_Stream_Open(filename.c_str(), 0, 0, 0);
	if(music==NULL)
    {
        std::cerr << "Erreur dans le chargement de la musique du niveau" << std::endl;
        exit(4);
    }
	if(loop){FSOUND_Stream_SetLoopCount(music, -1);}

}

void Clevel::playmusic(bool PlayOrNot)
{

	if(PlayOrNot){FSOUND_Stream_Play(FSOUND_FREE, music);}else{FSOUND_Stream_Stop(music);}

}

void Clevel::updatescore()
{

	++score;

}

void Clevel::resetscore()
{

	score=0;

}

