#include "main.h"


Cplayer::~Cplayer()
{

	glDeleteTextures(1,&surface);
	FSOUND_Sample_Free(sound);

}


void Cplayer::load(string filename, int sizeX, int sizeY, int framesX, int framesY)
{

	size_X=sizeX; size_Y=sizeY; 
	frames_X=framesX; frames_Y=framesY;

	rectsrc.x = 0;
	rectsrc.y = 0;
	rectsrc.w = size_X/frames_X;
	rectsrc.h = size_Y/frames_Y;

	SDL_Surface *temp;

	glGenTextures (1, & surface);
    glBindTexture (GL_TEXTURE_2D, surface);

    // Paramtrage de la texture.
    glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
    glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
    glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);

    temp = IMG_Load(filename.c_str());
	if(temp==NULL)
    {
        std::cerr << "Erreur dans le chargement de l'image du joueur" << std::endl;
        exit(3);
    }

    // Jonction entre OpenGL et SDL.
    glTexImage2D (GL_TEXTURE_2D, 0, GL_RGBA, temp->w, temp->h, 0,
    GL_RGBA, GL_UNSIGNED_BYTE, temp-> pixels);

	SDL_FreeSurface(temp);

}


void Cplayer::draw()
{

	rectdest.x=pos_X;
	rectdest.y=pos_Y;

	glEnable(GL_ALPHA_TEST);
	glAlphaFunc(GL_GREATER, 0.5f);

	glBindTexture (GL_TEXTURE_2D, surface);


    glBegin(GL_QUADS);

        glTexCoord2f ((float)rectsrc.x/(float)size_X, (float)rectsrc.y/(float)size_Y);
		glVertex2i(pos_X, pos_Y);

        glTexCoord2f ((float)rectsrc.x/(float)size_X, ((float)rectsrc.y+(float)rectsrc.h)/(float)size_Y);
		glVertex2i(pos_X, pos_Y + rectsrc.h);

        glTexCoord2f (((float)rectsrc.x+(float)rectsrc.w)/(float)size_X, ((float)rectsrc.y+(float)rectsrc.h)/(float)size_Y);
		glVertex2i(pos_X + rectsrc.w, pos_Y + rectsrc.h);

        glTexCoord2f (((float)rectsrc.x+(float)rectsrc.w)/(float)size_X, (float)rectsrc.y/(float)size_Y);
		glVertex2i(pos_X + rectsrc.w, pos_Y);

    glEnd(); 

	glDisable(GL_ALPHA_TEST);


}



void Cplayer::setaction(int _way, int _movement)
{

	way=_way;
	movement=_movement;
	
	rectsrc.x = movement*(size_X/frames_X);
	rectsrc.y = way*size_Y/frames_Y;
	rectsrc.w = size_X/frames_X;
	rectsrc.h = size_Y/frames_Y;

}

void Cplayer::loadsound(string filename)
{

	sound = FSOUND_Sample_Load( FSOUND_FREE, filename.c_str(), 0, 0, 0);
	if(sound==NULL)
    {
        std::cerr << "Erreur dans le chargement du son du menu" << std::endl;
        exit(4);
    }

}

void Cplayer::playsound()
{

	FSOUND_PlaySound (FSOUND_FREE, sound);

}
