#include "main.h"


static int puissance2sup(int i)
{
    double logbase2 = log((double)i) / log((double)2);
    //return Round(pow(2.0, ceil(logbase2)));
	return (int)pow(2.0, ceil(logbase2));
}


bool Ctext::LoadFont(string police, int size, int R, int G, int B)
{
	color.r=R;
	color.g=G;
	color.b=B;

	font = TTF_OpenFont(police.c_str(), size);
    if(font==NULL) {
        return false;
    }
	rectsrc.x = 0;
	rectsrc.y = 0;
	rectsrc.w = 100;
	rectsrc.h = 70;

    return true;
}


bool Ctext::DrawText(string message)
{
    if(message != this->message) {
        if(this->message != "") {
            glDeleteTextures(1,&surface);
        }

        this->message = message;

        if(message != "") {
            //Cration de la texture du sprite
            SDL_Surface *temp;

            glGenTextures (1, & surface);
            glBindTexture (GL_TEXTURE_2D, surface);

            // Paramtrage de la texture.
            glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
            glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
            glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
            glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);

            temp = TTF_RenderText_Blended(font, message.c_str(), color);

            if(temp != NULL) {
                //Calcul de taille
                int w = puissance2sup(temp->w);
                int h = puissance2sup(temp->h);

                SDL_Surface *temp2=SDL_CreateRGBSurface(
                    SDL_HWSURFACE,
                    w,
                    h,
                    32,
                    temp->format->Rmask,
                    temp->format->Gmask,
                    temp->format->Bmask,
                    temp->format->Amask);

                if(temp2 == NULL) {
                    SDL_FreeSurface(temp);
                    return false;
                }
                maxx = (float)temp->w;
                maxx /= w;
                maxy = (float)temp->h;
                maxy /= h;

                SDL_BlitSurface(temp, NULL, temp2, &rectsrc);

                // Jonction entre OpenGL et SDL.
                glTexImage2D (GL_TEXTURE_2D, 0, GL_RGBA, temp2->w, temp2->h, 0,
                                GL_RGBA, GL_UNSIGNED_BYTE, temp2->pixels);

                SDL_FreeSurface(temp);
                SDL_FreeSurface(temp2);
            }
            else {
                return false;
            }
        }
    }

    glBindTexture (GL_TEXTURE_2D, surface);

	glEnable(GL_ALPHA_TEST);
	glBlendFunc(GL_ONE,GL_ONE);
	glEnable(GL_BLEND);
	glAlphaFunc(GL_LESS,0.9);
    glEnable(GL_TEXTURE_2D);
    glBegin(GL_QUADS);
        glTexCoord2f (0, 0);
		glVertex2f(rectdest.x, rectdest.y);

        glTexCoord2f (0, maxy);
		glVertex2f(rectdest.x, rectdest.y + rectsrc.h);

        glTexCoord2f (maxx, maxy);
		glVertex2f(rectdest.x + rectsrc.w, rectdest.y + rectsrc.h);

        glTexCoord2f (maxx, 0);
		glVertex2f(rectdest.x + rectsrc.w, rectdest.y);
    glEnd();
    glDisable(GL_ALPHA_TEST);
    glDisable(GL_BLEND);

    return true;
}


void Ctext::SetPosition(int x, int y)
{
	rectdest.x = x;
	rectdest.y = y;
}
